commit 4879a8ee30c0c440cc515e5e81c694215996d213
Author: Eric Botcazou <ebotcazou@adacore.com>
Date:   Mon Sep 28 09:00:46 2020 +0200

    Fix bogus alignment warning on address clause
    
    The compiler gives a bogus alignment warning on an address clause and
    a discriminated record type with variable size.
    
    gcc/ada/ChangeLog:
            * gcc-interface/decl.c (maybe_saturate_size): Add ALIGN parameter
            and round down the result to ALIGN.
            (gnat_to_gnu_entity): Adjust calls to maybe_saturate_size.
    
    gcc/testsuite/ChangeLog:
            * gnat.dg/addr16.adb: New test.
            * gnat.dg/addr16_pkg.ads: New helper.

diff --git a/gcc/testsuite/gnat.dg/addr16.adb b/gcc/testsuite/gnat.dg/addr16.adb
new file mode 100644
index 00000000000..8f09da023fb
--- /dev/null
+++ b/gcc/testsuite/gnat.dg/addr16.adb
@@ -0,0 +1,14 @@
+-- { dg-do compile }
+
+with Addr16_Pkg; use Addr16_Pkg;
+
+procedure Addr16 (R : Rec) is
+
+  pragma Unsuppress (Alignment_Check);
+
+  B : Integer;
+  for B'Address use R.A'Address;
+
+begin
+  null;
+end;
diff --git a/gcc/testsuite/gnat.dg/addr16_pkg.ads b/gcc/testsuite/gnat.dg/addr16_pkg.ads
new file mode 100644
index 00000000000..9a1b9e3b21b
--- /dev/null
+++ b/gcc/testsuite/gnat.dg/addr16_pkg.ads
@@ -0,0 +1,9 @@
+package Addr16_Pkg is
+
+  type Arr is array (Positive range <>) of Long_Long_Integer;
+
+  type Rec (D : Positive) is record
+    A : Arr (1 .. D);
+  end record;
+
+end Addr16_Pkg;

